;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;        Copyright 2001-2002 The Removers, all rights reserved.
;;         Copying is covered by the GNU General Public License.

;;    This program is free software; you can redistribute it and/or modify
;;    it under the terms of the GNU General Public License as published by
;;    the Free Software Foundation; either version 2 of the License, or
;;    (at your option) any later version.

;;    This program is distributed in the hope that it will be useful,
;;    but WITHOUT ANY WARRANTY; without even the implied warranty of
;;    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
;;    GNU General Public License for more details.

**************************
* Instruction Set 68HC11 *
*   Translation table.   *
**************************

	DATA
translation_table:
; dc.b n,octet_1,...,octet_n (de l'opcode sans compter paramtres)
; even
; dc.l adr routine
; dc.w nb_cycles
; n=0 si table termine !!
; adresse suivant=adr actuel+(n+1[+1])+4
* ABA
	dc.b	1
	dc.b	$1b
	even
	dc.l	_aba
	dc.w	2
* ABX	
	dc.b	1
	dc.b	$3a
	even
	dc.l	_abx
	dc.w	3
* ABY	
	dc.b	2
	dc.b	$18
	dc.b	$3a
	even
	dc.l	_aby
	dc.w	4
* ADCA (imm)
	dc.b	1
	dc.b	$89
	even
	dc.l	_adca_imm
	dc.w	2
* ADCA (dir)
	dc.b	1
	dc.b	$99
	even
	dc.l	_adca_dir
	dc.w	3
* ADCA (ext)
	dc.b	1
	dc.b	$b9
	even
	dc.l	_adca_ext
	dc.w	4
* ADCA (ind_x)
	dc.b	1
	dc.b	$a9
	even
	dc.l	_adca_ind_x
	dc.w	4
* ADCA (ind_y)
	dc.b	2
	dc.b	$18
	dc.b	$a9
	even
	dc.l	_adca_ind_y
	dc.w	5
* ADCB (imm)
	dc.b	1
	dc.b	$c9
	even
	dc.l	_adcb_imm
	dc.w	2
* ADCB (dir)
	dc.b	1
	dc.b	$d9
	even
	dc.l	_adcb_dir
	dc.w	3
* ADCB (ext)
	dc.b	1
	dc.b	$f9
	even
	dc.l	_adcb_ext
	dc.w	4
* ADCB (ind_x)
	dc.b	1
	dc.b	$e9
	even
	dc.l	_adcb_ind_x
	dc.w	4
* ADCB (ind_y)
	dc.b	2
	dc.b	$18
	dc.b	$e9
	even
	dc.l	_adcb_ind_y
	dc.w	5	
* ADDA (imm)
	dc.b	1
	dc.b	$8b
	even
	dc.l	_adda_imm
	dc.w	2
* ADDA (dir)
	dc.b	1
	dc.b	$9b
	even
	dc.l	_adda_dir
	dc.w	3
* ADDA (ext)
	dc.b	1
	dc.b	$bb
	even
	dc.l	_adda_ext
	dc.w	4
* ADDA (ind_x)
	dc.b	1
	dc.b	$ab
	even
	dc.l	_adda_ind_x
	dc.w	4
* ADDA (ind_y)
	dc.b	2
	dc.b	$18
	dc.b	$ab
	even
	dc.l	_adda_ind_y
	dc.w	5
* ADDB (imm)
	dc.b	1
	dc.b	$cb
	even
	dc.l	_addb_imm
	dc.w	2
* ADDB (dir)
	dc.b	1
	dc.b	$db
	even
	dc.l	_addb_dir
	dc.w	3
* ADDB (ext)
	dc.b	1
	dc.b	$fb
	even
	dc.l	_addb_ext
	dc.w	4
* ADDB (ind_x)
	dc.b	1
	dc.b	$eb
	even
	dc.l	_addb_ind_x
	dc.w	4
* ADDB (ind_y)
	dc.b	2
	dc.b	$18
	dc.b	$eb
	even
	dc.l	_addb_ind_y
	dc.w	5
* ADDD (imm)
	dc.b	1
	dc.b	$c3
	even
	dc.l	_addd_imm
	dc.w	4
* ADDD (dir)
	dc.b	1
	dc.b	$d3
	even
	dc.l	_addd_dir
	dc.w	5
* ADDD (ext)
	dc.b	1
	dc.b	$f3
	even
	dc.l	_addd_ext
	dc.w	6
* ADDD (ind_x)
	dc.b	1
	dc.b	$e3
	even
	dc.l	_addd_ind_x
	dc.w	6
* ADDD (ind_y)
	dc.b	2
	dc.b	$18
	dc.b	$e3
	even
	dc.l	_addd_ind_y
	dc.w	7
* ANDA (imm)
	dc.b	1
	dc.b	$84
	even
	dc.l	_anda_imm
	dc.w	2
* ANDA (dir)
	dc.b	1
	dc.b	$94
	even
	dc.l	_anda_dir
	dc.w	3
* ANDA (ext)
	dc.b	1
	dc.b	$b4
	even
	dc.l	_anda_ext
	dc.w	4
* ANDA (ind_x)
	dc.b	1
	dc.b	$a4
	even
	dc.l	_anda_ind_x
	dc.w	4
* ANDA (ind_y)
	dc.b	2
	dc.b	$18
	dc.b	$a4
	even
	dc.l	_anda_ind_y
	dc.w	5
* ANDB (imm)
	dc.b	1
	dc.b	$c4
	even
	dc.l	_andb_imm
	dc.w	2
* ANDB (dir)
	dc.b	1
	dc.b	$d4
	even
	dc.l	_andb_dir
	dc.w	3
* ANDB (ext)
	dc.b	1
	dc.b	$f4
	even
	dc.l	_andb_ext
	dc.w	4
* ANDB (ind_x)
	dc.b	1
	dc.b	$e4
	even
	dc.l	_andb_ind_x
	dc.w	4
* ANDB (ind_y)
	dc.b	2
	dc.b	$18
	dc.b	$e4
	even
	dc.l	_andb_ind_y
	dc.w	5
* ASRA
	dc.b	1
	dc.b	$47
	even
	dc.l	_asra
	dc.w	2
* ASRB
	dc.b	1
	dc.b	$57
	even
	dc.l	_asrb
	dc.w	2
* ASR (ext)
	dc.b	1
	dc.b	$77
	even
	dc.l	_asr_ext
	dc.w	6
* ASR (ind_x)
	dc.b	1
	dc.b	$67
	even
	dc.l	_asr_ind_x
	dc.w	6
* ASR (ind_y)
	dc.b	2
	dc.b	$18
	dc.b	$67
	even
	dc.l	_asr_ind_y
	dc.w	7

* BCC
	dc.b	1
	dc.b	$24
	even
	dc.l	_bcc
	dc.w	3
* BCLR (dir)
	dc.b	1
	dc.b	$15
	even
	dc.l	_bclr_dir
	dc.w	6
* BCLR (ind_x)
	dc.b	1
	dc.b	$1d
	even
	dc.l	_bclr_ind_x
	dc.w	7
* BCLR (ind_y)
	dc.b	2
	dc.b	$18
	dc.b	$1d
	even
	dc.l	_bclr_ind_y
	dc.w	8
* BCS
	dc.b	1
	dc.b	$25
	even
	dc.l	_bcs
	dc.w	3
* BEQ
	dc.b	1
	dc.b	$27
	even
	dc.l	_beq	
	dc.w	3
* BGE
	dc.b	1
	dc.b	$2c
	even
	dc.l	_bge
	dc.w	3
* BGT
	dc.b	1
	dc.b	$2e
	even
	dc.l	_bgt
	dc.w	3
* BHI
	dc.b	1
	dc.b	$22
	even
	dc.l	_bhi
	dc.w	3
* BITA (imm)
	dc.b	1
	dc.b	$85
	even
	dc.l	_bita_imm
	dc.w	2
* BITA (dir)
	dc.b	1
	dc.b	$95
	even
	dc.l	_bita_dir
	dc.w	3
* BITA (ext)
	dc.b	1
	dc.b	$b5
	even
	dc.l	_bita_ext
	dc.w	4
* BITA (ind_x)
	dc.b	1
	dc.b	$a5
	even
	dc.l	_bita_ind_x
	dc.w	4
* BITA (ind_y)
	dc.b	2
	dc.b	$18
	dc.b	$a5
	even
	dc.l	_bita_ind_y
	dc.w	5
* BITB (imm)
	dc.b	1
	dc.b	$c5
	even
	dc.l	_bitb_imm
	dc.w	2
* BITB (dir)
	dc.b	1
	dc.b	$d5
	even
	dc.l	_bitb_dir
	dc.w	3
* BITB (ext)
	dc.b	1
	dc.b	$f5
	even
	dc.l	_bitb_ext
	dc.w	4
* BITB (ind_x)
	dc.b	1
	dc.b	$e5
	even
	dc.l	_bitb_ind_x
	dc.w	4
* BITB (ind_y)
	dc.b	2
	dc.b	$18
	dc.b	$e5
	even
	dc.l	_bitb_ind_y
	dc.w	5
* BLE
	dc.b	1
	dc.b	$2f
	even
	dc.l	_ble
	dc.w	3
* BLS
	dc.b	1
	dc.b	$23
	even
	dc.l	_bls
	dc.w	3
* BLT
	dc.b	1
	dc.b	$2d
	even
	dc.l	_blt
	dc.w	3
* BMI
	dc.b	1
	dc.b	$2b
	even
	dc.l	_bmi
	dc.w	3
* BNE
	dc.b	1
	dc.b	$26
	even
	dc.l	_bne
	dc.w	3
* BPL
	dc.b	1
	dc.b	$2a
	even
	dc.l	_bpl
	dc.w	3
* BRA
	dc.b	1
	dc.b	$20
	even
	dc.l	_bra
	dc.w	3
* BRCLR (dir)
	dc.b	1
	dc.b	$13
	even
	dc.l	_brclr_dir
	dc.w	6
* BRCLR (ind_x)
	dc.b	1
	dc.b	$1f
	even
	dc.l	_brclr_ind_x
	dc.w	7
* BRCLR (ind_y)
	dc.b	2
	dc.b	$18
	dc.b	$1f
	even
	dc.l	_brclr_ind_y
	dc.w	8
* BRN
	dc.b	1
	dc.b	$21
	even
	dc.l	_brn
	dc.w	3
* BRSET (dir)
	dc.b	1
	dc.b	$12
	even
	dc.l	_brset_dir
	dc.w	6
* BRSET (ind_x)
	dc.b	1
	dc.b	$1e
	even
	dc.l	_brset_ind_x
	dc.w	7
* BRSET (ind_y)
	dc.b	2
	dc.b	$18
	dc.b	$1e
	even
	dc.l	_brset_ind_y
	dc.w	8
* BSET (dir)
	dc.b	1
	dc.b	$14
	even
	dc.l	_bset_dir
	dc.w	6
* BSET (ind_x)
	dc.b	1
	dc.b	$1c
	even
	dc.l	_bset_ind_x
	dc.w	7
* BSET (ind_y)
	dc.b	2
	dc.b	$18
	dc.b	$1c
	even
	dc.l	_bset_ind_y
	dc.w	8
* BSR
	dc.b	1
	dc.b	$8d
	even
	dc.l	_bsr
	dc.w	6
* BVC
	dc.b	1
	dc.b	$28
	even
	dc.l	_bvc
	dc.w	3
* BVS
	dc.b	1
	dc.b	$29
	even
	dc.l	_bvs
	dc.w	3

* CBA
	dc.b	1
	dc.b	$11
	even
	dc.l	_cba
	dc.w	2
* CLC
	dc.b	1
	dc.b	$c
	even
	dc.l	_clc
	dc.w	2
* CLI
	dc.b	1
	dc.b	$e
	even
	dc.l	_cli
	dc.w	2
* CLRA
	dc.b	1
	dc.b	$4f
	even
	dc.l	_clra
	dc.w	2
* CLRB
	dc.b	1
	dc.b	$5f
	even
	dc.l	_clrb
	dc.w	2
* CLR (ext)
	dc.b	1
	dc.b	$7f
	even
	dc.l	_clr_ext
	dc.w	6
* CLR (ind_x)
	dc.b	1
	dc.b	$6f
	even
	dc.l	_clr_ind_x
	dc.w	6
* CLR (ind_y)
	dc.b	2
	dc.b	$18
	dc.b	$6f
	even
	dc.l	_clr_ind_y
	dc.w	7
* CLV
	dc.b	1
	dc.b	$a
	even
	dc.l	_clv
	dc.w	2
* CMPA (imm)
	dc.b	1
	dc.b	$81
	even
	dc.l	_cmpa_imm
	dc.w	2
* CMPA (dir)
	dc.b	1
	dc.b	$91
	even
	dc.l	_cmpa_dir
	dc.w	3
* CMPA (ext)
	dc.b	1
	dc.b	$b1
	even
	dc.l	_cmpa_ext
	dc.w	4
* CMPA (ind_x)
	dc.b	1
	dc.b	$a1
	even
	dc.l	_cmpa_ind_x
	dc.w	4
* CMPA (ind_y)
	dc.b	2
	dc.b	$18
	dc.b	$a1
	even
	dc.l	_cmpa_ind_y
	dc.w	5
* CMPB (imm)
	dc.b	1
	dc.b	$c1
	even
	dc.l	_cmpb_imm
	dc.w	2
* CMPB (dir)
	dc.b	1
	dc.b	$d1
	even
	dc.l	_cmpb_dir
	dc.w	3
* CMPB (ext)
	dc.b	1
	dc.b	$f1
	even
	dc.l	_cmpb_ext
	dc.w	4
* CMPB (ind_x)
	dc.b	1
	dc.b	$e1
	even
	dc.l	_cmpb_ind_x
	dc.w	4
* CMPB (ind_y)
	dc.b	2
	dc.b	$18
	dc.b	$e1
	even
	dc.l	_cmpb_ind_y
	dc.w	5
* COMA
	dc.b	1
	dc.b	$43
	even
	dc.l	_coma
	dc.w	2
* COMB
	dc.b	1
	dc.b	$53
	even
	dc.l	_comb
	dc.w	2
* COM (ext)
	dc.b	1
	dc.b	$73
	even
	dc.l	_com_ext
	dc.w	6
* COM (ind_x)
	dc.b	1
	dc.b	$63
	even
	dc.l	_com_ind_x
	dc.w	6
* COM (ind_y)
	dc.b	2
	dc.b	$18
	dc.b	$63
	even
	dc.l	_com_ind_y
	dc.w	7
* CPD (imm)
	dc.b	2
	dc.b	$1a
	dc.b	$83
	even
	dc.l	_cpd_imm
	dc.w	5
* CPD (dir)
	dc.b	2
	dc.b	$1a
	dc.b	$93
	even
	dc.l	_cpd_dir
	dc.w	6
* CPD (ext)
	dc.b	2
	dc.b	$1a
	dc.b	$b3
	even
	dc.l	_cpd_ext
	dc.w	7
* CPD (ind_x)
	dc.b	2
	dc.b	$1a
	dc.b	$a3
	even
	dc.l	_cpd_ind_x
	dc.w	7
* CPD (ind_y)
	dc.b	2
	dc.b	$cd
	dc.b	$a3
	even
	dc.l	_cpd_ind_y
	dc.w	7
* CPX (imm)
	dc.b	1
	dc.b	$8c
	even
	dc.l	_cpx_imm
	dc.w	4
* CPX (dir)
	dc.b	1
	dc.b	$9c
	even
	dc.l	_cpx_dir
	dc.w	5
* CPX (ext)
	dc.b	1
	dc.b	$bc
	even
	dc.l	_cpx_ext
	dc.w	6
* CPX (ind_x)
	dc.b	1
	dc.b	$ac
	even
	dc.l	_cpx_ind_x
	dc.w	6
* CPX (ind_y)
	dc.b	2
	dc.b	$cd
	dc.b	$ac
	even
	dc.l	_cpx_ind_y
	dc.w	7
* CPY (imm)
	dc.b	2
	dc.b	$18
	dc.b	$8c
	even
	dc.l	_cpy_imm
	dc.w	5
* CPY (dir)
	dc.b	2
	dc.b	$18
	dc.b	$9c
	even
	dc.l	_cpy_dir
	dc.w	6
* CPY (ext)
	dc.b	2
	dc.b	$18
	dc.b	$bc
	even
	dc.l	_cpy_ext
	dc.w	7
* CPY (ind_x)
	dc.b	2
	dc.b	$1a
	dc.b	$ac
	even
	dc.l	_cpy_ind_x
	dc.w	7
* CPY (ind_y)
	dc.b	2
	dc.b	$18
	dc.b	$ac
	even
	dc.l	_cpy_ind_y
	dc.w	7

* DAA
	dc.b	1
	dc.b	$19
	even
	dc.l	_daa
	dc.w	2
* DECA
	dc.b	1
	dc.b	$4a
	even
	dc.l	_deca
	dc.w	2
* DECB
	dc.b	1
	dc.b	$5a
	even
	dc.l	_decb
	dc.w	2
* DEC (ext)
	dc.b	1
	dc.b	$7a
	even
	dc.l	_dec_ext
	dc.w	6
* DEC (ind_x)
	dc.b	1
	dc.b	$6a
	even
	dc.l	_dec_ind_x
	dc.w	6
* DEC (ind_y)
	dc.b	2
	dc.b	$18
	dc.b	$6a
	even
	dc.l	_dec_ind_y
	dc.w	7
* DES
	dc.b	1
	dc.b	$34
	even
	dc.l	_des
	dc.w	3
* DEX
	dc.b	1
	dc.b	$9
	even
	dc.l	_dex
	dc.w	3
* DEY
	dc.b	2
	dc.b	$18
	dc.b	$9
	even
	dc.l	_dey
	dc.w	4

* EORA (imm)
	dc.b	1
	dc.b	$88
	even
	dc.l	_eora_imm
	dc.w	2
* EORA (dir)
	dc.b	1
	dc.b	$98
	even
	dc.l	_eora_dir
	dc.w	3
* EORA (ext)
	dc.b	1
	dc.b	$b8
	even
	dc.l	_eora_ext
	dc.w	4
* EORA (ind_x)
	dc.b	1
	dc.b	$a8
	even
	dc.l	_eora_ind_x
	dc.w	4
* EORA (ind_y)
	dc.b	2
	dc.b	$18
	dc.b	$a8
	even
	dc.l	_eora_ind_y
	dc.w	5
* EORB (imm)
	dc.b	1
	dc.b	$c8
	even
	dc.l	_eorb_imm
	dc.w	2
* EORB (dir)
	dc.b	1
	dc.b	$d8
	even
	dc.l	_eorb_dir
	dc.w	3
* EORB (ext)
	dc.b	1
	dc.b	$f8
	even
	dc.l	_eorb_ext
	dc.w	4
* EORB (ind_x)
	dc.b	1
	dc.b	$e8
	even
	dc.l	_eorb_ind_x
	dc.w	4
* EORB (ind_y)
	dc.b	2
	dc.b	$18
	dc.b	$e8
	even
	dc.l	_eorb_ind_y
	dc.w	5

* FDIV
	dc.b	1
	dc.b	$3
	even
	dc.l	_fdiv
	dc.w	41

* IDIV
	dc.b	1
	dc.b	$2
	even
	dc.l	_idiv
	dc.w	41
* INCA
	dc.b	1
	dc.b	$4c
	even
	dc.l	_inca
	dc.w	2
* INCB
	dc.b	1
	dc.b	$5c
	even
	dc.l	_incb
	dc.w	2
* INC (ext)
	dc.b	1
	dc.b	$7c
	even
	dc.l	_inc_ext
	dc.w	6
* INC (ind_x)
	dc.b	1
	dc.b	$6c
	even
	dc.l	_inc_ind_x
	dc.w	6
* INC (ind_y)
	dc.b	2
	dc.b	$18
	dc.b	$6c
	even
	dc.l	_inc_ind_y
	dc.w	7
* INS
	dc.b	1
	dc.b	$31
	even
	dc.l	_ins
	dc.w	3
* INX
	dc.b	1
	dc.b	$8
	even
	dc.l	_inx
	dc.w	3
* INY
	dc.b	2
	dc.b	$18
	dc.b	$8
	even
	dc.l	_iny
	dc.w	4

* JMP (ext)
	dc.b	1
	dc.b	$7e
	even
	dc.l	_jmp_ext
	dc.w	3
* JMP (ind_x)
	dc.b	1
	dc.b	$6e
	even
	dc.l	_jmp_ind_x
	dc.w	3
* JMP (ind_y)
	dc.b	2
	dc.b	$18
	dc.b	$6e
	even
	dc.l	_jmp_ind_y
	dc.w	4
* JSR (dir)
	dc.b	1
	dc.b	$9d
	even
	dc.l	_jsr_dir
	dc.w	5
* JSR (ext)
	dc.b	1
	dc.b	$bd
	even
	dc.l	_jsr_ext
	dc.w	6
* JSR (ind_x)
	dc.b	1
	dc.b	$ad
	even
	dc.l	_jsr_ind_x
	dc.w	6
* JSR (ind_y)
	dc.b	2
	dc.b	$18
	dc.b	$ad
	even
	dc.l	_jsr_ind_y
	dc.w	7

* LDAA (imm)
	dc.b	1
	dc.b	$86
	even
	dc.l	_ldaa_imm
	dc.w	2
* LDAA (dir)
	dc.b	1
	dc.b	$96
	even
	dc.l	_ldaa_dir
	dc.w	3
* LDAA (ext)
	dc.b	1
	dc.b	$b6
	even
	dc.l	_ldaa_ext
	dc.w	4
* LDAA (ind_x)
	dc.b	1
	dc.b	$a6
	even
	dc.l	_ldaa_ind_x
	dc.w	4
* LDAA (ind_y)
	dc.b	2
	dc.b	$18
	dc.b	$a6
	even
	dc.l	_ldaa_ind_y
	dc.w	5
* LDAB (imm)
	dc.b	1
	dc.b	$c6
	even
	dc.l	_ldab_imm
	dc.w	2
* LDAB (dir)
	dc.b	1
	dc.b	$d6
	even
	dc.l	_ldab_dir
	dc.w	3
* LDAB (ext)
	dc.b	1
	dc.b	$f6
	even
	dc.l	_ldab_ext
	dc.w	4
* LDAB (ind_x)
	dc.b	1
	dc.b	$e6
	even
	dc.l	_ldab_ind_x
	dc.w	4
* LDAB (ind_y)
	dc.b	2
	dc.b	$18
	dc.b	$e6
	even
	dc.l	_ldab_ind_y
	dc.w	5
* LDD (imm)
	dc.b	1
	dc.b	$cc
	even
	dc.l	_ldd_imm
	dc.w	3
* LDD (dir)
	dc.b	1
	dc.b	$dc
	even
	dc.l	_ldd_dir
	dc.w	4
* LDD (ext)
	dc.b	1
	dc.b	$fc
	even
	dc.l	_ldd_ext
	dc.w	5
* LDD (ind_x)
	dc.b	1
	dc.b	$ec
	even
	dc.l	_ldd_ind_x
	dc.w	5
* LDD (ind_y)
	dc.b	2
	dc.b	$18
	dc.b	$ec
	even
	dc.l	_ldd_ind_y
	dc.w	6
* LDS (imm)
	dc.b	1
	dc.b	$8e
	even
	dc.l	_lds_imm
	dc.w	3
* LDS (dir)
	dc.b	1
	dc.b	$9e
	even
	dc.l	_lds_dir
	dc.w	4
* LDS (ext)
	dc.b	1
	dc.b	$be
	even
	dc.l	_lds_ext
	dc.w	5
* LDS (ind_x)
	dc.b	1
	dc.b	$ae
	even
	dc.l	_lds_ind_x
	dc.w	5
* LDS (ind_y)
	dc.b	2
	dc.b	$18
	dc.b	$ae
	even
	dc.l	_lds_ind_y
	dc.w	6
* LDX (imm)
	dc.b	1
	dc.b	$ce
	even
	dc.l	_ldx_imm
	dc.w	3
* LDX (dir)
	dc.b	1
	dc.b	$de
	even
	dc.l	_ldx_dir
	dc.w	4
* LDX (ext)
	dc.b	1
	dc.b	$fe
	even
	dc.l	_ldx_ext
	dc.w	5
* LDX (ind_x)
	dc.b	1
	dc.b	$ee
	even
	dc.l	_ldx_ind_x
	dc.w	5
* LDX (ind_y)
	dc.b	2
	dc.b	$cd
	dc.b	$ee
	even
	dc.l	_ldx_ind_y
	dc.w	6
* LDY (imm)
	dc.b	2
	dc.b	$18
	dc.b	$ce
	even
	dc.l	_ldy_imm
	dc.w	4
* LDY (dir)
	dc.b	2
	dc.b	$18
	dc.b	$de
	even
	dc.l	_ldy_dir
	dc.w	5
* LDY (ext)
	dc.b	2
	dc.b	$18
	dc.b	$fe
	even
	dc.l	_ldy_ext
	dc.w	6
* LDY (ind_x)
	dc.b	2
	dc.b	$1a
	dc.b	$ee
	even
	dc.l	_ldy_ind_x
	dc.w	6
* LDY (ind_y)
	dc.b	2
	dc.b	$18
	dc.b	$ee
	even
	dc.l	_ldy_ind_y
	dc.w	6
* LSLA
	dc.b	1
	dc.b	$48
	even
	dc.l	_lsla
	dc.w	2
* LSLB
	dc.b	1
	dc.b	$58
	even
	dc.l	_lslb
	dc.w	2
* LSL (ext)
	dc.b	1
	dc.b	$78
	even
	dc.l	_lsl_ext
	dc.w	6
* LSL (ind_x)
	dc.b	1
	dc.b	$68
	even
	dc.l	_lsl_ind_x
	dc.w	6
* LSL (ind_y)
	dc.b	2
	dc.b	$18
	dc.b	$68
	even
	dc.l	_lsl_ind_y
	dc.w	7
* LSLD
	dc.b	1
	dc.b	$5
	even
	dc.l	_lsld
	dc.w	3
* LSRA
	dc.b	1
	dc.b	$44
	even
	dc.l	_lsra
	dc.w	2
* LSRB
	dc.b	1
	dc.b	$54
	even
	dc.l	_lsrb
	dc.w	2
* LSR (ext)
	dc.b	1
	dc.b	$74
	even
	dc.l	_lsr_ext
	dc.w	6
* LSR (ind_x)
	dc.b	1
	dc.b	$64
	even
	dc.l	_lsr_ind_x
	dc.w	6
* LSR (ind_y)
	dc.b	2
	dc.b	$18
	dc.b	$64
	even
	dc.l	_lsr_ind_y
	dc.w	7
* LSRD
	dc.b	1
	dc.b	$4
	even
	dc.l	_lsrd
	dc.w	3	

* MUL
	dc.b	1
	dc.b	$3d
	even
	dc.l	_mul
	dc.w	10
	
* NEGA
	dc.b	1
	dc.b	$40
	even
	dc.l	_nega
	dc.w	2
* NEGB
	dc.b	1
	dc.b	$50
	even
	dc.l	_negb
	dc.w	2	
* NEG (ext)
	dc.b	1
	dc.b	$70
	even
	dc.l	_neg_ext
	dc.w	6
* NEG (ind_x)
	dc.b	1
	dc.b	$60
	even
	dc.l	_neg_ind_x
	dc.w	6
* NEG (ind_y)
	dc.b	2
	dc.b	$18
	dc.b	$60
	even
	dc.l	_neg_ind_y
	dc.w	7
* NOP
	dc.b	1
	dc.b	$1
	even
	dc.l	_nop
	dc.w	2
	
* ORAA (imm)
	dc.b	1
	dc.b	$8a
	even
	dc.l	_oraa_imm
	dc.w	2
* ORAA (dir)
	dc.b	1
	dc.b	$9a
	even
	dc.l	_oraa_dir
	dc.w	3
* ORAA (ext)
	dc.b	1
	dc.b	$ba
	even
	dc.l	_oraa_ext
	dc.w	4
* ORAA (ind_x)
	dc.b	1
	dc.b	$aa
	even
	dc.l	_oraa_ind_x
	dc.w	4
* ORAA (ind_y)
	dc.b	2
	dc.b	$18
	dc.b	$aa
	even
	dc.l	_oraa_ind_y
	dc.w	5
* ORAB (imm)
	dc.b	1
	dc.b	$ca
	even
	dc.l	_orab_imm
	dc.w	2
* ORAB (dir)
	dc.b	1
	dc.b	$da
	even
	dc.l	_orab_dir
	dc.w	3
* ORAB (ext)
	dc.b	1
	dc.b	$fa
	even
	dc.l	_orab_ext
	dc.w	4
* ORAB (ind_x)
	dc.b	1
	dc.b	$ea
	even
	dc.l	_orab_ind_x
	dc.w	4
* ORAB (ind_y)
	dc.b	2
	dc.b	$18
	dc.b	$ea
	even
	dc.l	_orab_ind_y
	dc.w	5

* PSHA
	dc.b	1
	dc.b	$36
	even
	dc.l	_psha
	dc.w	3
* PSHB
	dc.b	1
	dc.b	$37
	even
	dc.l	_pshb
	dc.w	3
* PSHX
	dc.b	1
	dc.b	$3c
	even
	dc.l	_pshx
	dc.w	4
* PSHY
	dc.b	2
	dc.b	$18
	dc.b	$3c
	even
	dc.l	_pshy
	dc.w	5
* PULA
	dc.b	1
	dc.b	$32
	even
	dc.l	_pula
	dc.w	4
* PULB
	dc.b	1
	dc.b	$33
	even
	dc.l	_pulb
	dc.w	4
* PULX
	dc.b	1
	dc.b	$38
	even
	dc.l	_pulx
	dc.w	5
* PULY
	dc.b	2
	dc.b	$18
	dc.b	$38
	even
	dc.l	_puly
	dc.w	6

* ROLA
	dc.b	1
	dc.b	$49
	even
	dc.l	_rola
	dc.w	2
* ROLB
	dc.b	1
	dc.b	$59
	even
	dc.l	_rolb
	dc.w	2
* ROL (ext)
	dc.b	1
	dc.b	$79
	even
	dc.l	_rol_ext
	dc.w	6
* ROL (ind_x)
	dc.b	1
	dc.b	$69
	even
	dc.l	_rol_ind_x
	dc.w	6
* ROL (ind_x)
	dc.b	2
	dc.b	$18
	dc.b	$69
	even
	dc.l	_rol_ind_y
	dc.w	7
* RORA
	dc.b	1
	dc.b	$46
	even
	dc.l	_rora
	dc.w	2
* RORB
	dc.b	1
	dc.b	$56
	even
	dc.l	_rorb
	dc.w	2
* ROR (ext)
	dc.b	1
	dc.b	$76
	even
	dc.l	_ror_ext
	dc.w	6
* ROR (ind_x)
	dc.b	1
	dc.b	$66
	even
	dc.l	_ror_ind_x
	dc.w	6
* ROR (ind_y)
	dc.b	2
	dc.b	$18
	dc.b	$66
	even
	dc.l	_ror_ind_y
	dc.w	7
* RTI
	dc.b	1
	dc.b	$3b
	even
	dc.l	_rti
	dc.w	12
* RTS
	dc.b	1
	dc.b	$39
	even
	dc.l	_rts
	dc.w	5

* SBA
	dc.b	1
	dc.b	$10
	even
	dc.l	_sba
	dc.w	2
* SBCA (imm)
	dc.b	1
	dc.b	$82
	even
	dc.l	_sbca_imm
	dc.w	2
* SBCA (dir)
	dc.b	1
	dc.b	$92
	even
	dc.l	_sbca_dir
	dc.w	3
* SBCA (ext)
	dc.b	1
	dc.b	$b2
	even
	dc.l	_sbca_ext
	dc.w	4
* SBCA (ind_x)
	dc.b	1
	dc.b	$a2
	even
	dc.l	_sbca_ind_x
	dc.w	4
* SBCA (ind_y)
	dc.b	2
	dc.b	$18
	dc.b	$a2
	even
	dc.l	_sbca_ind_y
	dc.w	5
* SBCB (imm)
	dc.b	1
	dc.b	$c2
	even
	dc.l	_sbcb_imm
	dc.w	2
* SBCB (dir)
	dc.b	1
	dc.b	$d2
	even
	dc.l	_sbcb_dir
	dc.w	3
* SBCB (ext)
	dc.b	1
	dc.b	$f2
	even
	dc.l	_sbcb_ext
	dc.w	4
* SBCB (ind_x)
	dc.b	1
	dc.b	$e2
	even
	dc.l	_sbcb_ind_x
	dc.w	4
* SBCB (ind_y)
	dc.b	2
	dc.b	$18
	dc.b	$e2
	even
	dc.l	_sbcb_ind_y
	dc.w	5
* SEC
	dc.b	1
	dc.b	$d
	even
	dc.l	_sec
	dc.w	2
* SEI
	dc.b	1
	dc.b	$f
	even
	dc.l	_sei
	dc.w	2
* SEV
	dc.b	1
	dc.b	$0b
	even
	dc.l	_sev
	dc.w	2
* STAA (dir)
	dc.b	1
	dc.b	$97
	even
	dc.l	_staa_dir
	dc.w	3
* STAA (ext)
	dc.b	1
	dc.b	$b7
	even
	dc.l	_staa_ext
	dc.w	4
* STAA (ind_x)
	dc.b	1
	dc.b	$a7
	even
	dc.l	_staa_ind_x
	dc.w	4
* STAA (ind_y)
	dc.b	2
	dc.b	$18
	dc.b	$a7
	even
	dc.l	_staa_ind_y
	dc.w	5
* STAB (dir)
	dc.b	1
	dc.b	$d7
	even
	dc.l	_stab_dir
	dc.w	3
* STAB (ext)
	dc.b	1
	dc.b	$f7
	even
	dc.l	_stab_ext
	dc.w	4
* STAB (ind_x)
	dc.b	1
	dc.b	$e7
	even
	dc.l	_stab_ind_x
	dc.w	4
* STAB (ind_y)
	dc.b	2
	dc.b	$18
	dc.b	$e7
	even
	dc.l	_stab_ind_y
	dc.w	5
* STD (dir)
	dc.b	1
	dc.b	$dd
	even
	dc.l	_std_dir
	dc.w	4
* STD (ext)
	dc.b	1
	dc.b	$fd
	even
	dc.l	_std_ext
	dc.w	5
* STD (ind_x)
	dc.b	1
	dc.b	$ed
	even
	dc.l	_std_ind_x
	dc.w	5
* STD (ind_y)
	dc.b	2
	dc.b	$18
	dc.b	$ed
	even
	dc.l	_std_ind_y
	dc.w	6
* STS (dir)
	dc.b	1
	dc.b	$9f
	even
	dc.l	_sts_dir
	dc.w	4
* STS (ext)
	dc.b	1
	dc.b	$bf
	even
	dc.l	_sts_ext
	dc.w	5
* STS (ind_x)
	dc.b	1
	dc.b	$af
	even
	dc.l	_sts_ind_x
	dc.w	5
* STS (ind_y)
	dc.b	2
	dc.b	$18
	dc.b	$af
	even
	dc.l	_sts_ind_y
	dc.w	6
* STX (dir)
	dc.b	1
	dc.b	$df
	even
	dc.l	_stx_dir
	dc.w	4
* STX (ext)
	dc.b	1
	dc.b	$ff
	even
	dc.l	_stx_ext
	dc.w	5
* STX (ind_x)
	dc.b	1
	dc.b	$ef
	even
	dc.l	_stx_ind_x
	dc.w	5
* STX (ind_y)
	dc.b	2
	dc.b	$cd
	dc.b	$ef
	even
	dc.l	_stx_ind_y
	dc.w	6
* STY (dir)
	dc.b	2
	dc.b	$18
	dc.b	$df
	even
	dc.l	_sty_dir
	dc.w	5
* STY (ext)
	dc.b	2
	dc.b	$18
	dc.b	$ff
	even
	dc.l	_sty_ext
	dc.w	6
* STY (ind_x)
	dc.b	2
	dc.b	$1a
	dc.b	$ef
	even
	dc.l	_sty_ind_x
	dc.w	6
* STY (ind_y)
	dc.b	2
	dc.b	$18
	dc.b	$ef
	even
	dc.l	_sty_ind_y
	dc.w	6
* SUBA (imm)
	dc.b	1
	dc.b	$80
	even
	dc.l	_suba_imm
	dc.w	2
* SUBA (dir)
	dc.b	1
	dc.b	$90
	even
	dc.l	_suba_dir
	dc.w	3
* SUBA (ext)
	dc.b	1
	dc.b	$b0
	even
	dc.l	_suba_ext
	dc.w	4
* SUBA (ind_x)
	dc.b	1
	dc.b	$a0
	even
	dc.l	_suba_ind_x
	dc.w	4
* SUBA (ind_y)
	dc.b	2
	dc.b	$18
	dc.b	$a0
	even
	dc.l	_suba_ind_y
	dc.w	5
* SUBB (imm)
	dc.b	1
	dc.b	$c0
	even
	dc.l	_subb_imm
	dc.w	2
* SUBB (dir)
	dc.b	1
	dc.b	$d0
	even
	dc.l	_subb_dir
	dc.w	3
* SUBB (ext)
	dc.b	1
	dc.b	$f0
	even
	dc.l	_subb_ext
	dc.w	4
* SUBB (ind_x)
	dc.b	1
	dc.b	$e0
	even
	dc.l	_subb_ind_x
	dc.w	4
* SUBB (ind_y)
	dc.b	2
	dc.b	$18
	dc.b	$e0
	even
	dc.l	_subb_ind_y
	dc.w	5
* SUBD (imm)
	dc.b	1
	dc.b	$83
	even
	dc.l	_subd_imm
	dc.w	4
* SUBD (dir)
	dc.b	1
	dc.b	$93
	even
	dc.l	_subd_dir
	dc.w	5
* SUBD (ext)
	dc.b	1
	dc.b	$b3
	even
	dc.l	_subd_ext
	dc.w	6
* SUBD (ind_x)
	dc.b	1
	dc.b 	$a3
	even
	dc.l	_subd_ind_x
	dc.w	6
* SUBD (ind_y)
	dc.b	2
	dc.b	$18
	dc.b	$a3
	even
	dc.l	_subd_ind_y
	dc.w	7

* TAB
	dc.b	1
	dc.b	$16
	even
	dc.l	_tab
	dc.w	2
* TAP
	dc.b	1
	dc.b	$6
	even
	dc.l	_tap
	dc.w	2
* TBA
	dc.b	1
	dc.b	$17
	even
	dc.l	_tba
	dc.w	2
* TPA
	dc.b	1
	dc.b	$7
	even
	dc.l	_tpa
	dc.w	2
* TSTA
	dc.b	1
	dc.b	$4d
	even
	dc.l	_tsta
	dc.w	2
* TSTB
	dc.b	1
	dc.b	$5d
	even
	dc.l	_tstb
	dc.w	2
* TST (ext)
	dc.b	1
	dc.b	$7d
	even
	dc.l	_tst_ext
	dc.w	6
* TST (ind_x)
	dc.b	1
	dc.b	$6d
	even
	dc.l	_tst_ind_x
	dc.w	6
* TST (ind_y)
	dc.b	2
	dc.b	$18
	dc.b	$6d
	even
	dc.l	_tst_ind_y
	dc.w	7
* TSX
	dc.b	1
	dc.b	$30
	even
	dc.l	_tsx
	dc.w	3
* TSY
	dc.b	2
	dc.b	$18
	dc.b	$30
	even
	dc.l	_tsy
	dc.w	4
* TXS
	dc.b	1
	dc.b	$35
	even
	dc.l	_txs
	dc.w	3
* TXY
	dc.b	2
	dc.b	$18
	dc.b	$35
	even
	dc.l	_tys
	dc.w	4

* XGDX:
	dc.b	1
	dc.b	$8f
	even
	dc.l	_xgdx
	dc.w	3
* XGDY:
	dc.b	2
	dc.b	$18
	dc.b	$8f
	even
	dc.l	_xgdy
	dc.w	4

* The end	
	dc.b	0
	even	