;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;        Copyright 2001-2002 The Removers, all rights reserved.
;;         Copying is covered by the GNU General Public License.

;;    This program is free software; you can redistribute it and/or modify
;;    it under the terms of the GNU General Public License as published by
;;    the Free Software Foundation; either version 2 of the License, or
;;    (at your option) any later version.

;;    This program is distributed in the hope that it will be useful,
;;    but WITHOUT ANY WARRANTY; without even the implied warranty of
;;    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
;;    GNU General Public License for more details.

	include	'wind_def.s'

TAB:	equ	%111

	TEXT
prompt_line:
; a0 : adresse de la ligne
	movem.l	d0-d2/a0-a2,-(sp)
	clr.w	d0
	move.w	prompt.line(a0),d1
	move.w	#80,d2
	move.w	#25,d3
	bsr	set_clipping_rect
	bsr	__goto_l_c
	bsr	__erase_line
	movem.l	d0-d7/a0-a6,-(sp)
	move.l	prompt.prompt(a0),a6
	bsr	clear_on
	bsr	putstring
	bsr	clear_off
;	move.l	prompt.prompt(a0),-(sp)
;	move.w	#9,-(sp)
;	trap	#1
;	addq.w	#6,sp
	movem.l	(sp)+,d0-d7/a0-a6
	move.w	prompt.max_len(a0),d1
	tst.l	prompt.text(a0)
	beq.s	.no_saisie
	move.l	prompt.text(a0),a1
	move.l	a0,-(sp)
	subq.w	#1,d1
	blt.s	.end_saisie
.saisie_txt:
	move.w	d1,-(sp)
	move.l	a1,-(sp)
	move.w	#7,-(sp)
	trap	#1		; Crawcin
	addq.w	#2,sp
	move.l	(sp)+,a1
	move.w	(sp)+,d1
	cmp.b	#13,d0
	beq.s	.end_saisie
	movem.l	d0-d7/a0-a6,-(sp)
	bsr	putchar
	movem.l	(sp)+,d0-d7/a0-a6
	move.b	d0,(a1)+	
	dbf	d1,.saisie_txt
.end_saisie:
	clr.b	(a1)
	move.l	(sp)+,a0
.no_saisie:
	tst.w	prompt.clear_flag(a0)
	beq.s	.no_clear
	bsr	__erase_line
.no_clear:
	movem.l	(sp)+,d0-d2/a0-a2
	rts	

interface_init:
; a0 : adresse de l'interface
	move.l	a0,-(sp)
	bsr.s	win_init
	move.l	(sp)+,a0
.init_loop:
	move.l	a0,-(sp)
	move.l	interface.window(a0),d0
	beq.s	.end_init
	move.l	d0,a0
	tst.w	window.opened(a0)
	beq.s	.no_aff
	bsr	draw_window
.no_aff:
	move.l	(sp)+,a0
	add.w	#interface.sizeof,a0
	bra.s	.init_loop
.end_init:
	addq.w	#4,sp
	rts

win_init:
	movem.l	d0-d2/a0-a2,-(sp)
;	pea	.init(pc)
;	move.w	#9,-(sp)
;	trap	#1
;	addq.w	#6,sp
	bsr	manager_init
	bsr	control_on
	movem.l	(sp)+,d0-d2/a0-a2
	rts
.init:
	dc.b	27,'E',27,'f',27,'w',0
	even

interface_redraw:
; a0 : interface
.redraw_loop:
	move.l	a0,-(sp)
	move.l	interface.window(a0),d0
	beq.s	.end_redraw
	move.l	d0,a0
	tst.w	window.opened(a0)
	beq.s	.no_redraw
;	bsr	draw_window_title_bar
	tst.l	window.redraw(a0)
	beq.s	.no_redraw
	move.l	window.redraw(a0),a1
	jsr	(a1)
.no_redraw:
	move.l	(sp)+,a0
	add.w	#interface.sizeof,a0
	bra.s	.redraw_loop
.end_redraw:
	addq.w	#4,sp
	rts

get_active_window:
; a0 : interface
; rsultat dans d0 et a0
.seek_loop:
	move.l	a0,-(sp)
	move.l	interface.window(a0),d0
	beq.s	.end_seek
	move.l	d0,a0
	tst.w	window.active(a0)
	bne.s	.end_seek
	move.l	(sp)+,a0
	add.w	#interface.sizeof,a0
	bra.s	.seek_loop
.end_seek:
	addq.w	#4,sp
	move.l	d0,a0
	rts
	
switch_active_window:
; a0 : interface
	move.l	a0,-(sp)
.seek_loop:
	move.l	a0,-(sp)
	move.l	interface.window(a0),d0
	beq.s	.end_seek
	move.l	d0,a0
	tst.w	window.active(a0)
	bne.s	.end_seek
	move.l	(sp)+,a0
	add.w	#interface.sizeof,a0
	bra.s	.seek_loop
.end_seek:
	tst.l	d0
	beq.s	.error
	not.w	window.active(a0)
	bsr	draw_window_title_bar
	move.l	(sp)+,a0
	move.l	(sp)+,a1
	add.w	#interface.sizeof,a0
	move.l	interface.window(a0),d0
	bne.s	.not_last
.last:
	move.l	interface.window(a1),d0
	bne.s	.not_last
	rts
.not_last:
	move.l	d0,a0
	not.w	window.active(a0)
	bsr	draw_window_title_bar
	rts	
.error:	
	addq.w	#8,sp
	rts

draw_window:
; a0 : fentre
; en fait, cela n'affiche que les contours
	movem.l	d0-d7/a0-a2,-(sp)
	move.w	window.up_x(a0),d0
	move.w	window.up_y(a0),d1
	move.w	window.down_x(a0),d2
	move.w	window.down_y(a0),d3
	move.l	window.title(a0),a1
	bsr	__exg_coord
	bsr	__goto_l_c
	move.w	#' ',d4
	tst.w	window.active(a0)
	beq.s	.ok_win
	move.w	#'',d4
.ok_win:
	bsr	__draw_bord_l
	bsr	__goto_l_c
	bsr	__make_title
.line:
	addq.w	#1,d1
	cmp.w	d1,d3
	beq.s	.line_end
	bsr	__goto_l_c
	bsr	__draw_bord_c
	bra.s	.line
.line_end:
	move.w	d3,d1
	bsr	__goto_l_c
	move.w	#' ',d4
	bsr	__draw_bord_l
	movem.l	(sp)+,d0-d7/a0-a2
	rts

clear_window:
; efface toute la fentre (y compris l'intrieur)
; a0 : fentre
	movem.l	d0-d7/a0-a6,-(sp)
	move.w	window.up_x(a0),d0
	move.w	window.up_y(a0),d1
	move.w	window.down_x(a0),d2
	move.w	window.down_y(a0),d3
;	addq.w	#1,d2
;	addq.w	#1,d3
	bsr	set_clipping_rect
	bsr	clear_zone
	movem.l	(sp)+,d0-d7/a0-a6
	rts
;	bsr	__exg_coord
;	addq.w	#1,d3
;.line:
;	bsr	__goto_l_c
;	bsr	__clear_line
;	addq.w	#1,d1
;	cmp.w	d1,d3
;	bne.s	.line
;.line_end:
;	movem.l	(sp)+,d0-d7/a0-a6
;	rts

draw_window_content:
; a0 : adresse de la fentre
; a1 : adresse du texte
	movem.l	d0-d7/a0-a6,-(sp)
	move.w	window.up_x(a0),d0
	move.w	window.up_y(a0),d1
	move.w	window.down_x(a0),d2
	move.w	window.down_y(a0),d3
	bsr	wrap_off
	tst.w	window.wrap(a0)
	beq.s	.ok_wrap
	bsr	wrap_on
.ok_wrap:
	addq.w	#1,d0
	addq.w	#1,d1
	subq.w	#1,d2
*	subq.w	#1,d3
	bsr	set_clipping_rect
	move.l	a1,a6
	bsr	putstring
	movem.l	(sp)+,d0-d7/a0-a6
	rts	
;	move.w	window.wrap(a0),d5
;	bsr	__exg_coord
;	addq.w	#1,d0
;	subq.w	#1,d2
;.line:
;	addq.w	#1,d1		; avance d'une ligne
;	cmp.w	d1,d3
;	beq.s	.line_end
;	bsr	__goto_l_c
;	bsr	__aff_line	; et avance le pointeur  la ligne suivante
;	bra.s	.line
;.line_end:
;	movem.l	(sp)+,d0-d7/a0-a2
;	rts

draw_window_line:
; a0 : fentre
; a1 : texte
; d0 : numro de ligne
	movem.l	d0-d7/a0-a6,-(sp)
	move.w	d0,d5
	move.w	window.up_x(a0),d0
	move.w	window.up_y(a0),d1
	move.w	window.down_x(a0),d2
	move.w	window.down_y(a0),d3
	bsr	wrap_off
	tst.w	window.wrap(a0)
	beq.s	.ok_wrap
	bsr	wrap_on
.ok_wrap:
	addq.w	#1,d0
	addq.w	#1,d1
	subq.w	#1,d2
*	subq.w	#1,d3
	bsr	set_clipping_rect
	move.l	a1,a6
	bsr	putstring
	movem.l	(sp)+,d0-d7/a0-a6
	rts
;	bsr	__exg_coord
;	addq.w	#1,d0
;	subq.w	#1,d2
;	add.w	d1,d5
;	cmp.w	d1,d5
;	ble.s	.no_text
;	cmp.w	d3,d5
;	bge.s	.no_text
;	move.w	d5,d1
;	bsr	__goto_l_c
;	move.w	window.wrap(a0),d5
;	bsr	__aff_line
;.no_text:
;	movem.l	(sp)+,d0-d7/a0-a2
;	rts

cconws_window:
; a0 : fentre
; a1 : texte
	movem.l	d0-d7/a0-a6,-(sp)
	move.w	window.up_x(a0),d0
	move.w	window.up_y(a0),d1
	move.w	window.down_x(a0),d2
	move.w	window.down_y(a0),d3
	bsr	wrap_off
	tst.w	window.wrap(a0)
	beq.s	.wrap_ok
	bsr	wrap_on
.wrap_ok:
	addq.w	#1,d0
	addq.w	#1,d1
	subq.w	#1,d2
*	subq.w	#1,d3
	bsr	set_clipping_rect
;	bsr	__exg_coord
	subq.w	#1,d0
	subq.w	#1,d1
	add.w	window.column(a0),d0	; position dans
	add.w	window.line(a0),d1	; la fentre
	move.l	a0,-(sp)
	bsr	move_curseur
	move.l	a1,a6
	bsr	putstring
	move.l	(sp)+,a0
	bsr	get_curseur
	sub.w	window.up_x(a0),d0
	sub.w	window.up_y(a0),d1
	move.w	d0,window.column(a0)
	move.w	d1,window.line(a0)
	movem.l	(sp)+,d0-d7/a0-a6
	rts
;	cmp.w	d0,d6
;	ble.s	.no_cconws
;	cmp.w	d2,d6
;	bge.s	.no_cconws
;	cmp.w	d1,d7
;	ble.s	.no_cconws
;	cmp.w	d3,d7
;	bge.s	.no_cconws
;	subq.w	#1,d2
;	move.w	window.wrap(a0),d5
;.loop:
;	bsr	__cconws_line	; affiche la ligne et avance dans le texte
;	tst.b	(a1)		; fin du texte ?
;	beq.s	.end_loop
;	cmp.w	d6,d2
;	bne.s	.end_loop
;	move.w	d0,d6
;	addq.w	#1,d6
;	tst.w	d5
;	beq.s	.no_cconws
;	addq.w	#1,d7
;	cmp.w	d3,d7
;	blt.s	.loop
;.end_loop:
;	cmp.w	d6,d2
;	bne.s	.no_cr
;.cr:
;	move.w	d0,d6
;	addq.w	#1,d6
;	addq.w	#1,d7
;.no_cr:
;	sub.w	d0,d6
;	sub.w	d1,d7
;	move.w	d6,window.column(a0)
;	move.w	d7,window.line(a0)
;.no_cconws:
;	movem.l	(sp)+,d0-d7/a0-a2
;	rts

draw_window_title_bar:
	movem.l	d0-d7/a0-a2,-(sp)
	move.w	window.up_x(a0),d0
	move.w	window.up_y(a0),d1
	move.w	window.down_x(a0),d2
	move.w	window.down_y(a0),d3
	bsr	set_clipping_rect
	move.l	window.title(a0),a1
	bsr	__exg_coord
	bsr	__goto_l_c
	move.w	#' ',d4
	tst.w	window.active(a0)
	beq.s	.ok_win
	move.w	#'',d4
.ok_win:
	bsr	__draw_bord_l
	bsr	__goto_l_c
	bsr	__make_title
	movem.l	(sp)+,d0-d7/a0-a2
	rts
	
__aff_line:
; d0 : numro de colonne (NON modifi)
; d5 : warp on/off
; a1 : adresse du texte (modifie)
	movem.l	d0-d7/a0/a2,-(sp)
.aff_car:
	move.b	(a1)+,d4
	beq.s	.end_aff_car
	cmp.b	#13,d4
	beq.s	.end_aff_car
	cmp.b	#9,d4
	beq.s	.tab
	bsr	__aff_car
	addq.w	#1,d0
	cmp.w	d0,d2
	bne.s	.aff_car
	bra.s	.end_aff_car
.tab:
	move.w	d0,d7
	and.w	#TAB,d7
	beq.s	.aff_car
	move.w	#' ',d4
	bsr	__aff_car
	addq.w	#1,d0
	cmp.w	d0,d2
	beq.s	.end_aff_car
	move.w	d0,d7
	and.w	#TAB,d7
	bne.s	.tab
	bra.s	.aff_car
.end_aff_car:
	tst.b	d4
	beq.s	.clear_end_line
	addq.w	#1,a1
	tst.w	d5
	bne.s	.clear_end_line
	subq.w	#2,a1
.search_end_string:	
	move.b	(a1)+,d4
	beq.s	.clear_end_line
	cmp.b	#13,d4
	bne.s	.search_end_string
	addq.w	#1,a1
.clear_end_line:	
	subq.w	#1,a1
	move.w	#' ',d4
.loop:
	cmp.w	d0,d2
	beq.s	.end_loop
	addq.w	#1,d0
	bsr.s	__aff_car
	bra.s	.loop
.end_loop:
.end_aff_line:
	movem.l	(sp)+,d0-d7/a0/a2
	rts

__cconws_line:
; d5 : warp on/off
; d6 : numro de colonne (modifi)
; a1 : adresse du texte (modifie)
	movem.l	d0-d5/d7/a0/a2,-(sp)
	exg	d0,d6
	exg	d1,d7
	bsr	__goto_l_c
	exg	d0,d6
	exg	d1,d7
.aff_car:
	move.b	(a1)+,d4
	beq.s	.end_aff_car
	cmp.b	#13,d4
	beq.s	.end_aff_car
	cmp.b	#9,d4
	beq.s	.tab
	bsr.s	__aff_car
	addq.w	#1,d6
	cmp.w	d6,d2
	bne.s	.aff_car
	bra.s	.end_aff_car
.tab:
	move.w	d6,d7
	and.w	#TAB,d7
	beq.s	.aff_car
	move.w	#' ',d4
	bsr.s	__aff_car
	addq.w	#1,d6
	cmp.w	d6,d2
	beq.s	.end_aff_car	
	move.w	d6,d7
	and.w	#TAB,d7
	bne.s	.tab
	bra.s	.aff_car
.end_aff_car:
	cmp.b	#13,d4
	beq.s	.cr
	tst.b	d4
	bne.s	.end_cconws_line
	subq.w	#1,a1
	bra.s	.end_cconws_line
.cr:
	move.w	d2,d6
.end_cconws_line:
	movem.l	(sp)+,d0-d5/d7/a0/a2
	rts

__aff_car:
; d4 = caractre
	movem.l	d0-d7/a0-a7,-(sp)
	clr.w	d0
	move.b	d4,d0
	bsr	putchar
;	and.w	#$ff,d4
;	move.w	d4,-(sp)
;	move.w	#2,-(sp)
;	trap	#1
;	addq.w	#4,sp
	movem.l	(sp)+,d0-d7/a0-a7
	rts

__make_title:
	movem.l	d0-d7/a0-a2,-(sp)
	move.l	a1,d7
	tst.l	d7
	beq.s	.end
	moveq	#0,d5
	tst.b	(a1)
	beq.s	.end
.count:
	addq.w	#1,d5
	tst.b	(a1)+
	bne.s	.count
	move.w	d2,d6
	sub.w	d0,d6
	sub.w	d5,d6
	asr.w	d6
	add.w	d0,d6
	exg.l	d0,d6
	bsr	__goto_l_c
	exg.l	d0,d6
	bsr	__inverse_on
	movem.l	a3-a6,-(sp)
	move.l	d7,a6
	bsr	putstring
	movem.l	(sp)+,a3-a6
;	move.l	d7,-(sp)
;	move.w	#9,-(sp)
;	trap	#1
;	addq.w	#6,sp
	bsr	__inverse_off
.end:
	movem.l	(sp)+,d0-d7/a0-a2
	rts

__exg_coord:
; rordonne d0,d2
; ainsi que d1,d3
	cmp.w	d0,d2
	bge.s	.ok_x
	exg	d0,d2
.ok_x:
	cmp.w	d1,d3
	bge.s	.ok_y
	exg	d1,d3
.ok_y:
	rts

__draw_bord_l:
; x_dep : d0
; x_arr : d2
	movem.l	d0-d7/a0-a2,-(sp)
	bsr.s	__inverse_on
	sub.w	d0,d2
	subq.w	#1,d2
	bmi.s	.fin
.aff:
	bsr.s	__aff_car
	dbf	d2,.aff
.fin:
	bsr.s	__inverse_off
	movem.l	(sp)+,d0-d7/a0-a2
	rts

__draw_bord_c:
; x_dep : d0
; x_arr : d2
	movem.l	d0-d7/a0-a2,-(sp)
	bsr.s	__inverse_on
	move.w	#' ',d4
	bsr	__aff_car
	bsr.s	__inverse_off
	addq.w	#1,d0
	subq.w	#1,d2
	sub.w	d0,d2
	subq.w	#1,d2
	bmi.s	.fin
.aff:
	bsr	__aff_car
	dbf	d2,.aff
.fin:
	bsr.s	__inverse_on
	bsr	__aff_car
	bsr.s	__inverse_off
	movem.l	(sp)+,d0-d7/a0-a2
	rts

__clear_line:
; x_dep : d0
; x_arr : d2
	movem.l	d0-d7/a0-a2,-(sp)
	sub.w	d0,d2
	subq.w	#1,d2
	bmi.s	.fin
	move.w	#' ',d4
.aff:
	bsr	__aff_car
	dbf	d2,.aff
.fin:
	movem.l	(sp)+,d0-d7/a0-a2
	rts


__inverse_on:
	bsr	inverse_on
	rts
;	movem.l	d0-d2/a0-a2,-(sp)
;	pea	.com(pc)
;	move.w	#9,-(sp)
;	trap	#1
;	addq.w	#6,sp
;	movem.l	(sp)+,d0-d2/a0-a2
;	rts
;.com:
;	dc.b	27,'p',0
;	even

__inverse_off:
	bsr	inverse_off
	rts
;	movem.l	d0-d2/a0-a2,-(sp)
;	pea	.com(pc)
;	move.w	#9,-(sp)
;	trap	#1
;	addq.w	#6,sp
;	movem.l	(sp)+,d0-d2/a0-a2
;	rts
;.com:
;	dc.b	27,'q',0
;	even
	
__goto_l_c:
; colonne : d0
; ligne   : d1
	bsr	move_curseur
	rts
;	movem.l	d0-d2/a0-a2,-(sp)
;	add.b	#32,d0
;	add.b	#32,d1
;	move.b	d0,.com+3
;	move.b	d1,.com+2	
;	pea	.com(pc)
;	move.w	#9,-(sp)
;	trap	#1
;	addq.w	#6,sp
;	movem.l	(sp)+,d0-d2/a0-a2
;	rts
;.com:
;	dc.b	27,"Y",32,32,0
;	even	
	
__erase_line:
	movem.l	d0-d2/a0-a2,-(sp)
;	pea	.com(pc)
;	move.w	#9,-(sp)
;	trap	#1
;	addq.w	#6,sp
	movem.l	(sp)+,d0-d2/a0-a2
	rts
.com:
	dc.b	27,'l',13,0
	even
	
	include	'manager.s'
